#!/usr/bin/perl

use Data::Dumper;
use CGI;
use CGI::Carp qw/ fatalsToBrowser /;
use XML::DOM;
use Digest::SHA1 qw(sha1_hex);

print "Content-type: text/html\n\n";

require("cfg_utils.pl");
require("config_xml.pl");
require("access.pl");
if (!ConnectionAllowed($ENV{"REMOTE_ADDR"}, $allowManagerConnect)) {
  print "Connection denied\n";
  exit;
}

my $cfg = loadConfig("Repository.xml");

if (!defined($cfg->{"man.user"})) {
  writehtpasswd("", ""); # just for sure
} else {
  config_checklogin({$cfg->{"man.user"} => $cfg->{"man.passwordHash"}});
}

my @errors;

$_POST = new CGI;

$fname = "MetaEditorRuleset.xml";

if ($fh = $_POST->upload('ruleset')) {
  if (open(TMPFILE, ">$fname")) {
    while ($line = <$fh>) {
      print TMPFILE $line;
    }
    close(TMPFILE);
    push @errors, "A szablyfile sikeresen elmentve.";
  } else {
    push @errors, "A szablyfile-t nem sikerlt elmenteni.";
  }
} else {
  push @errors, 'A szablyfile-t nem sikerlt elmenteni';
}

print <<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-2" />
<title>Config editor</title>
<link href="common.css" rel="stylesheet" type="text/css" />
</head>
<body class="defbody">
<div class="admhead">Szablyfile feltltse</div>
EOF
;

if ($#errors >= 0) {
  print '<center><div class="errorbox">';
  foreach $err (@errors) {
    print $err . "<br>";
  }
  print '</div></center>';
}

print <<EOF
</div>
</body>
</html>
EOF
;
