#!/usr/bin/perl

sub dumpIPlist {
  my ($name, $data) = @_;
  my $rv = "";
  $rv .= "	<$name>\n";
  @pieces = split(",", $data);
  foreach $value (@pieces) {
    if ($value ne "") {
      $rv .= "		<ip>" . $value . "</ip>\n";
    }
  }
  $rv .= "	</$name>\n";
}

sub confdata {
  my $d = shift;
  my $data;

  $data = '<?xml version="1.0" encoding="UTF-8"?>';

  $data .= q{
<repository xmlns="http://www.scriptum.hu/oai/repository/config/codexml">
	<database type="hu.scriptum.oai.server.jdbc.JdbcRepositoryDataProvider">
		<type><?=$d["db.type"]?></type>
		<host><?=$d["db.host"]?></host>
		<username><?=$d["db.username"]?></username>
		<password><?=$d["db.password"]?></password>
		<database><?=$d["db.database"]?></database>
		<table><?=$d["db.table"]?></table>
	</database>

	<settings>
		<supportSets>true</supportSets>
		<resumptionSize><?=$d["sett.res.size"]?></resumptionSize>
		<resumptionExpirationHours><?=$d["sett.res.exp"]?></resumptionExpirationHours>
	</settings>

	<modificationReport>
		<url><?=$d["mod.url"]?></url>
		<identifierParamName><?=$d["mod.idParParam"]?></identifierParamName>
		<schemaListParamName><?=$d["mod.schemaParName"]?></schemaListParamName>
	</modificationReport>

	<identification>
		<repositoryName><?=$d["id.repositoryName"]?></repositoryName>
		<repositoryId><?=$d["id.repositoryId"]?></repositoryId>
		<baseURL><?=$d["id.baseURL"]?></baseURL>
		<protocolVersion><?=$d["id.protocolVersion"]?></protocolVersion>
		<deletedRecord><?=$d["id.del"]?></deletedRecord>
		<adminEmail><?=$d["id.email"]?></adminEmail>
	</identification>

	<manager>
		<user><?=$d["man.user"]?></user>
		<passwordHash><?=$d["man.passwordHash"]?></passwordHash>
	</manager>
<?=IPLIST?>
	<metadataFormats>
		<!-- These are metadata formats for NDA -->
<?=FORMAT?>
	</metadataFormats>
</repository>
  };

  my $IPLIST = dumpIPlist("allowHarvesterConnect", $d->{"ip.harvester"}) .
    dumpIPlist("allowManagerConnect", $d->{"ip.manager"});
  $data =~ s/<\?=IPLIST\?>/$IPLIST/eg;

  $data =~ s/<\?=\$d\["db.type"\]\?>/$d->{"db.type"}/eg;
  $data =~ s/<\?=\$d\["db.host"\]\?>/$d->{"db.host"}/eg;
  $data =~ s/<\?=\$d\["db.username"\]\?>/$d->{"db.username"}/eg;
  $data =~ s/<\?=\$d\["db.password"\]\?>/$d->{"db.password"}/eg;
  $data =~ s/<\?=\$d\["db.database"\]\?>/$d->{"db.database"}/eg;
  $data =~ s/<\?=\$d\["db.table"\]\?>/$d->{"db.table"}/eg;
  $data =~ s/<\?=\$d\["sett.res.size"\]\?>/$d->{"sett.res.size"}/eg;
  $data =~ s/<\?=\$d\["sett.res.exp"\]\?>/$d->{"sett.res.exp"}/eg;
  $data =~ s/<\?=\$d\["mod.url"\]\?>/$d->{"mod.url"}/eg;
  $data =~ s/<\?=\$d\["mod.idParParam"\]\?>/$d->{"mod.idParParam"}/eg;
  $data =~ s/<\?=\$d\["mod.schemaParName"\]\?>/$d->{"mod.schemaParName"}/eg;
  $data =~ s/<\?=\$d\["id.repositoryName"\]\?>/$d->{"id.repositoryName"}/eg;
  $data =~ s/<\?=\$d\["id.repositoryId"\]\?>/$d->{"id.repositoryId"}/eg;
  $data =~ s/<\?=\$d\["id.baseURL"\]\?>/$d->{"id.baseURL"}/eg;
  $data =~ s/<\?=\$d\["id.protocolVersion"\]\?>/$d->{"id.protocolVersion"}/eg;
  $data =~ s/<\?=\$d\["id.del"\]\?>/$d->{"id.del"}/eg;
  $data =~ s/<\?=\$d\["id.email"\]\?>/$d->{"id.email"}/eg;
  $data =~ s/<\?=\$d\["man.user"\]\?>/$d->{"man.user"}/eg;
  $data =~ s/<\?=\$d\["man.passwordHash"\]\?>/$d->{"man.passwordHash"}/eg;

  $FORMAT = "";
  foreach $key (sort { $a <=> $b } keys %{$d->{"format"}}) {
    $format = $d->{"format"}->{$key};
    my $CSVMAP = q{
		<format name="<?=$format["name"]?>">
			<schema><?=$format["schema"]?></schema>
			<namespace><?=$format["namespace"]?></namespace>
			<rootElementName><?=$format["rootElementName"]?></rootElementName>
<?=CSVMAP?>
			<csvseparator><?=$format["csvseparator"]?></csvseparator>
		</format>
    };
    $CSVMAP =~ s/<\?=\$format\["name"\]\?>/$format->{"name"}/eg;
    $CSVMAP =~ s/<\?=\$format\["schema"\]\?>/$format->{"schema"}/eg;
    $CSVMAP =~ s/<\?=\$format\["namespace"\]\?>/$format->{"namespace"}/eg;
    $CSVMAP =~ s/<\?=\$format\["rootElementName"\]\?>/$format->{"rootElementName"}/eg;
    my $tmp = $format->{"csvseparator"};
    $tmp =~ s/\\t/\t/g;
    $CSVMAP =~ s/<\?=\$format\["csvseparator"\]\?>/$tmp/eg;
    my $y = "";
    my $i = 0;
    foreach $k (sort { $a <=> $b } keys %{$format->{"csv"}}) {
      my $csv = $format->{"csv"}->{$k};
      $y .= sprintf('			<csvmap column="%s" tag="%s" attribute="%s" />' . "\n", $i, $csv->{"tag"}, $csv->{"attribute"});
      $i++;
    }
    $CSVMAP =~ s/<\?=CSVMAP\?>/$y/eg;
    $FORMAT .= $CSVMAP;
  }

  $data =~ s/<\?=FORMAT\?>/$FORMAT/eg;
  return $data;
}

return 1;
