#!/usr/bin/perl

use POSIX qw(strftime);
use MIME::Base64;
use Storable qw(freeze thaw);
use WWW::Curl::easy;

require("oaidb.pl");
require("parameters_inc.pl");

sub ISO8601Date {
  my $timestamp = @_[0];
  if (! $timestamp) {
    $timestamp = time;
  }
  return strftime("%Y-%m-%dT%XZ", gmtime($timestamp));
}

sub return_bytes {
  return @_[0];
}

sub getRecords {
  return undef;
}

sub getRecordsNew {
  my $repository = @_[0];
  my $byexternal = @_[1];
  my $disconnect = @_[2];
  $byexternal = 0 if (!defined($byexternal));
  $disconnect = 1 if (!defined($disconnect));
  #TODO: disconnect tuti mashogy mukodik mint php-ban (?!)

  my $db = new transdb($repository->{"type"}, $repository->{"host"}, $repository->{"user"}, $repository->{"password"}, $repository->{"database"});
  $db->ErrorReporting($repository->{"warn"});
  my @sql = $db->selectall($repository->{"table"});
  return -1 if ($sql[0] == -1);
  my @records;
  foreach $rows (@sql) {
    $rows->{'id'} = $db->unescapestr($rows->{'id'});
    $rows->{'root_name'} = $db->unescapestr($rows->{'root_name'});
    $rows->{'externalid'} = $db->unescapestr($rows->{'externalid'});
    # TODO:dirty hacking - $maxid global
    if ($rows->{"id"} > $maxid) {
      $maxid = $rows->{"id"};
    }
    if ($byexternal) {
      $key = $rows->{"externalid"};
    } else {
      $key = $rows->{"id"};
    }
    if ($key ne "") {
      $records->{$key}->{$rows->{'root_name'}}->{"sett"} = $db->unescapestr($rows->{"sett"});
      $records->{$key}->{$rows->{'root_name'}}->{"created"} = $db->unescapedate($rows->{"created"});
      $records->{$key}->{$rows->{'root_name'}}->{"modified"} = $db->unescapedate($rows->{"modified"});
      $records->{$key}->{$rows->{'root_name'}}->{"deleted"} = $db->unescapedate($rows->{"deleted"});
      $records->{$key}->{$rows->{'root_name'}}->{"xml"} = $db->unescapestr($rows->{"xml"});
      $records->{$key}->{$rows->{'root_name'}}->{"harvestable"} = $db->unescapestr($rows->{"harvestable"});
      $records->{$key}->{$rows->{'root_name'}}->{"id"} = $rows->{'id'};
      $records->{$key}->{$rows->{'root_name'}}->{"root_name"} = $rows->{'root_name'};
      $records->{$key}->{$rows->{'root_name'}}->{"root_namespace"} = $db->unescapestr($rows->{"root_namespace"});
      $records->{$key}->{$rows->{'root_name'}}->{"externalid"} = $rows->{"externalid"};
    } elsif (!$byexternal) {
      print "BUG\n";
    }
  }
  if ($disconnect) {
    $db->SQL_disconnect();
  }
  return $records;
}

#usage example:
#print XMLtag("request", {"verb", "ListRecords", "metadataPrefix", "nda_bibliographic"}, "http://perl.oai.ht4/cgi-bin/oai.pl");
sub XMLtagStart {
  my ($tag, $qualifiers, $data) = @_;
  $s = sprintf("<%s", $tag);
  foreach my $key (keys(%$qualifiers)) {
    $s .= sprintf(" %s=\"%s\"", $key, $qualifiers->{$key});
  }
  $s .= sprintf(">");
  return $s;
}
sub XMLtagEnd {
  my ($tag, $qualifiers, $data) = @_;
  return sprintf("</%s>\n", $tag);
}
sub XMLtag {
  my ($tag, $qualifiers, $data) = @_;
  return sprintf("%s%s%s", XMLtagStart($tag, $qualifiers, $data), $data, XMLtagEnd($tag, $qualifiers, $data));
}

sub ExplodeID {
  my $data = shift;
  $data =~ s/^oai:[^:]+://;
  return $data;
}

sub ScriptURL {
  return "http" . ($ENV{'HTTPS'} ? "s" : "") . "://" . $ENV{'HTTP_HOST'} . $ENV{'SCRIPT_NAME'};
}

sub WriteRecord {
  my ($db, $table, $record) = @_;
  return $db->insert($table, {
    "id" => $db->escapestr($record->{"id"}),
    "sett" => $db->escapestr($record->{"sett"}),
    "created" => $db->escapedate($record->{"created"}),
    "modified" => $db->escapedate($record->{"modified"}),
    "deleted" => $db->escapedate($record->{"deleted"}),
    "xml" => $db->escapestr($record->{"xml"}),
    "harvestable" => $db->escapestr($record->{"harvestable"}),
    "root_name" => $db->escapestr($record->{"root_name"}),
    "root_namespace" => $db->escapestr($record->{"root_namespace"})});
}

# php funkciok perl implementacioi
# a parameterezesuk megfelel a php megfelelo funkcioi parameterezesevel
# az inputok/outputok nem szuksegszeruen kompatibilisak a php funkciokkal
sub htmlspecialchars {
  my $data = @_[0];
  $data =~ s/&/&amp;/g;
  $data =~ s/"/&quot;/g;
  $data =~ s/</&lt;/g;
  $data =~ s/>/&gt;/g;
  return $data;
}

sub serialize {
  my $data = @_[0];
  my $str = freeze(@_[0]);
  return $str;
}

sub unserialize {
  my $data = @_[0];
  %x = %{ thaw($data) };
  return \%x;
}

sub gzcompress {
  my $data = @_[0];
  return $data;
}

sub gzuncompress {
  my $data = @_[0];
  return $data;
}

sub base64_encode {
  my $data = @_[0];
  return encode_base64($data, '');
}

sub base64_decode {
  my $data = @_[0];
  return decode_base64($data);
}

sub rawurldecode {
  my $data = @_[0];
  $data =~ s/%([a-fA-F0-9]{2,2})/chr(hex($1))/eg;
  return $data;
}

sub rawurlencode {
  my $data = @_[0];
  $data =~ s/([\W])/"%" . uc(sprintf("%2.2x",ord($1)))/eg;
  return $data;
}

sub chunk {
  my ($clientp, $data) = @_;
  return 0;
}

sub triggerHarvester {
  my @schemaList = @_;
  my $dom, $lastChangeReport;

  my $FNchangeReport = "changeReport.xml";
  my $parser = new XML::DOM::Parser;

  if ((-f $FNchangeReport) && (! ($dom = $parser->parsefile($FNchangeReport)))) {
    $lastChangeReport = 0;
  } else {
    $lastChangeReport = getSubelementContent($dom, "lastChangeReport");
  }
  if ($lastChangeReport && ($lastChangeReport <= time()) && ($lastChangeReport > time() - $triggerHarvesterInterval)) {
    return 1;
  }

  if ($config->{"modificationReport.url"}) {
    open CHR, ">" . $FNchangeReport;
    print CHR "<lastChangeReport>" . time() . "</lastChangeReport>\n";
    close CHR;

    $ch = WWW::Curl::easy->new();
    $ch->setopt(CURLOPT_RETURNTRANSFER, 1);
    $ch->setopt(CURLOPT_MUTE, 1);
    $ch->setopt(CURLOPT_HEADER, 0);
    $ch->setopt(CURLOPT_TIMEOUT, 30);
    $ch->setopt(CURLOPT_WRITEFUNCTION, \&chunk);
    $ch->setopt(CURLOPT_HEADERFUNCTION, \&chunk);
    if($config->{"modificationReport.identifierParamName"} == "GET") {
      $ch->setopt(CURLOPT_URL, $config->{"modificationReport.url"} . '?' . $config->{"modificationReport.identifierParamName"} . '=' . rawurlencode($config->{"repositoryId"}) . '&' . $config->{"modificationReport.schemaListParamName"} . '=' . join(',', @schemaList));
	} else {
      $ch->setopt(CURLOPT_POST, 1);
      $ch->setopt(CURLOPT_URL, $config->{"modificationReport.url"});
      $ch->setopt(CURLOPT_POSTFIELDS, $config->{"modificationReport.identifierParamName"} . '=' . rawurlencode($config->{"repositoryId"}) . '&' . $config->{"modificationReport.schemaListParamName"} . '=' . join(',', @schemaList));
	}

    $ch->perform();
    $ch->cleanup();
  }
}

sub isHarvestable {
  my $xml = shift;

  if ($xml =~ m#<[^>]*source/?>#i) {
    if ($xml =~ m#<[^>]*source>[^<]*(http|ftp)s?://.*\.#i) {
      return 1;
    } else {
      return 0;
    }
  }
  return 1;
}

sub ynHarvestable {
  my $xml = shift;

  return (isHarvestable($xml) ? "y" : "n");
}

return 1;
